
#define F_CPU 1000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrubt>
ISR(TIM1_COMPA_vect){
  PORTA ^= (1<<PA3); // toggle LED
}

int main (void) {
    DDRA = 0b00001000; // set PA3 as output in DDRA;
    TCCR1B |= (1<<WGM12); // Enable timmer1 CTC mode
    sei(); //enable global interrupt
    TIMSK1 |= (1<<0CIE1A); // enable CTC interrubt TCNT1=OCR1A
    OCR1A = 15625; // at 1/64 prescaler is exactly 1s
    TCCR1B |= (1<<CS11);
    TCCR1B |= (1<<CS10); These 2 register set the prescaler  to 1/64 and start counter


while(1) {

}
}
