# Laser Cutter

## Introduction

Trotec Speedy 400 is laser cutter used to cut different types of materials like paper, plastic, wood and metal. It is equipped with CO2 laser and can cut with a speed of 3.5 m/sec and power of 120w. The laser cutter can be used to engrave, cut and mark. The power and speed of the laser is defined by the type of the material and the thickness required. There are many pre-defined materials with the cutting specifications, but to add a new material, cutting test with different power and speed should be conducted to find out the best specification.

## Machine installation

![](images/7.jpg)

The machine comes as one piece. It does not need to assembled, the only main thing that needs to be installed is the exhaust. The exhaust extracts the smoke produced by the cutting and send it out of the building.

#### Problem

We have stayed in the simple installation process for one day!. The machine has a LED which tells if the machine is ready or not. That LED was blinking each time we started the machine, blinking means that the machine door is open. We thought that the problem is with the door's sensors, we tested the sensors by putting a small round magnetic on each of them, but the LED kept blinking. At the end of the day we have solved it by installing one single tool made for safety reasons.

![](images/8.jpg)

## Printing

#### Set up the machine

The machine is very easy to set up for cutting. The only thing to do before starting the cutting is setting up the laser focus by placing the tool in the laser head and raising the plate until it touches the tool.

![](images/6.jpg)

#### Prepare the drawing

The first time I used the laser cutter, I decided to engrave my name on the back cover of my phone. I have wrote my name in a website and copied it inkscape.

![](images/2.jpg)

The black color is very important,each color represents a process with its specifications, like engraving is Black, cutting is Red. These colors can be changed and the specifications can be also changed in material database in the laser cutter software.

![](images/1.jpg)

back to inkscape, my name is ready and the dimensions of it is acceptable. To send it to the laser cutter software, I have pressed **CTRL + P** then print then defined the material of my back cover and pressed send.

![](images/3.jpg)
![](images/4.jpg)

The drawing can be found in the jpbs menu of the software, I have imported and place it in the middle of the indicator. I did not know the best power, I was afraid of burning my phone so I have started with 0w then 20w and then raised it to 40w which gave me a good engraving.

![](images/5.jpg)

#### Video

<video width="640" height="480" autoplay loop> <source src=" ./videos/1.mp4" type="video/mp4">
your browser dose not support the video tag.
</video>
